require "selenium-webdriver"
require "rspec"
require "./spec/spec_helper"
require "./pages/provider_login"
include RSpec::Expectations


describe "My Mobile Desktop" do

  before(:all) do
    @driver = Selenium::WebDriver.for :firefox
    @base_url = "http://localhost"
    @port_and_directory = ":8080/my-mobile-desktop"
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 10
    @verification_errors = []

    @login = ProviderLogin.new @driver
    @login.loginAsCprs1234()
            
    @driver.get(@base_url + @port_and_directory)
  end
  
  after(:all) do
    @driver.quit
    @verification_errors.should == []
  end

  describe "About Button: PP-366" do
    it 'should display an About pop-up - PP-366, PP-367' do
      @driver.get(@base_url + @port_and_directory)
      !5.times{ break if (@driver.find_element(:id, "portal-about-btn").text == "About" rescue false); sleep 1 }
      @driver.find_element(:id, "portal-about-btn").click
      !5.times{ break if (@driver.find_element(:css, "#portal-about-popup > div.ui-header.ui-bar-b > h3.ui-title").text == 
                         "About" rescue false); sleep 1 }
      (@driver.find_element(:css, "#portal-about-popup > div.ui-header.ui-bar-b > h3.ui-title").text).should == "About"
      (@driver.find_element(:css, "#portal-about-popup ul li:nth-child(1) .fieldname").text).should == "Title"
      (@driver.find_element(:css, "#portal-about-popup ul li:nth-child(1) .fieldvalue").text).should == "My Mobile Desktop"
      (@driver.find_element(:css, "#portal-about-popup ul li:nth-child(2) .fieldname").text).should == "Version"
      (@driver.find_element(:css, "#portal-about-popup ul li:nth-child(2) .fieldvalue").text).should == "1.2.0"
      (@driver.find_element(:css, "p.ui-li-desc").text).should == "The My Mobile Desktop app provides the capability for clinicians to be aware of all published apps, applets, and recommended links within a common app.\nAdditional Information"
      @driver.find_element(:css, "#portal-about-popup a:first-of-type").click
    end   
    
  end

  describe "Version Number: PP-366" do
    it 'should be listed' do
      (@driver.find_element(:css, "#app-name > h1").text).should == "My Mobile Desktop - v1.2.0"
    end   
    
  end  
  
  
end
